package com.hotel.server;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import com.hotel.entity.User;
import com.hotel.entity.Menu;
import com.hotel.entity.Vip;
import com.hotel.util.Datas;
import com.hotel.util.SysConstants;
/**
 * ķ
 * @author xu.sun
 *
 */
public class ServerService{
	/**
	 * û
	 * @param userAccount
	 * @param userPwd
	 * @return
	 */
	public Datas userLogin(String userAccount, String userPwd) {
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");

		NodeList userList = doc.getElementsByTagName("User");
		for (int i = 0; i < userList.getLength(); i++) {
			Element elUser = (Element) userList.item(i);

			String userId = elUser.getElementsByTagName("userId").item(0)
					.getTextContent();
			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			String pwd = elUser.getElementsByTagName("userPwd").item(0)
					.getTextContent();
			String admin = elUser.getAttribute("admin");
			if (userAccount.equals(account) && userPwd.equals(pwd)) {
				if("yes".equals(admin)) {
					datas.setFlag(SysConstants.SYS_ADMINSUCCESS);
				} else if("no".equals(admin)) {
					User user = new User();
					user.setUserId(userId);
					user.setUserAccount(userAccount);
					datas.setUser(user);
					datas.setFlag(SysConstants.SYS_GENERALSUCCESS);
				}
				return datas;
			}

		}
		datas.setFlag(SysConstants.SYS_ERROR);
		return datas;
	}
	
	/**
	 * ûע
	 * @param userAccount
	 * @param userPwd
	 * @param userName
	 * @param userSex
	 * @param birthDay
	 * @param phoneNum
	 * @return
	 */
	public Datas userRegister(String limit,String userId,String userAccount,
			String userPwd,String userName,String phoneNum) {
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");
		Element elUsers = doc.getDocumentElement();
		
		NodeList userListNode = doc.getElementsByTagName("User");

		for (int i = 0; i < userListNode.getLength(); i++) {
			Element elUser = (Element) userListNode.item(i);
			String id = elUser.getElementsByTagName("userId").item(0).
					getTextContent();
			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if(userId.equals(id)) {
				datas.setFlag(SysConstants.SYS_USERIDISEXIST);
				return datas;
			}
			if(userAccount.equals(account)) {
				datas.setFlag(SysConstants.SYS_USERACCOUNTISEXIST);
				return datas;
			} 
		}
		
		
//		private String userAccount;
//		private String userPwd;
//		private String userName;
//		private String userSex;
//		private String birthDay;
//		private String phoneNum;
//		private List<FavoriteMenu> favoriteMenu;
//		private List<BuyMenu> BuyMenu;
		Element elUser = doc.createElement("User");
		elUser.setAttribute("admin", limit);
		Element elUserId = doc.createElement("userId");
		elUserId.setTextContent(userId);
		elUser.appendChild(elUserId);
		Element elUserAccount = doc.createElement("userAccount");
		elUserAccount.setTextContent(userAccount);
		elUser.appendChild(elUserAccount);
		Element elUserPwd = doc.createElement("userPwd");
		elUserPwd.setTextContent(userPwd);
		elUser.appendChild(elUserPwd);
		Element elUserName = doc.createElement("userName");
		elUserName.setTextContent(userName);
		elUser.appendChild(elUserName);
		Element elPhoneNum = doc.createElement("phoneNum");
		elPhoneNum.setTextContent(phoneNum);
		elUser.appendChild(elPhoneNum);		
		Element elBuyMenus = doc.createElement("buyMenus");
		elUser.appendChild(elBuyMenus);
		elUsers.appendChild(elUser);
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	public Datas addVip(String vipNum) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Vip.xml");
		Element elMembers = doc.getDocumentElement();
		
		NodeList memberListNode = doc.getElementsByTagName("Member");

		for (int i = 0; i < memberListNode.getLength(); i++) {
			Element elMember = (Element) memberListNode.item(i);
			String num = elMember.getElementsByTagName("vipNum").item(0).
					getTextContent();
			if(num.equals(vipNum)) {
				datas.setFlag(SysConstants.SYS_VIPNUMISEXIST);
				return datas;
			} 
		}
		Element elMember = doc.createElement("Member");

		Element elVipNum = doc.createElement("vipNum");
		elVipNum.setTextContent(vipNum);
		elMember.appendChild(elVipNum);
		Element elIntegral = doc.createElement("integral");
		elIntegral.setTextContent("0");
		elMember.appendChild(elIntegral);
		elMembers.appendChild(elMember);
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Vip.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Vip.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	/**
	 * ޸û
	 * @param userAccount
	 * @param newPwd
	 * @return
	 */
	public Datas ModifyPwd(String userAccount,String newPwd) { 
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");

		NodeList userList = doc.getElementsByTagName("User");
		for (int i = 0; i < userList.getLength(); i++) {
			Element elUser = (Element) userList.item(i);

			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			
			if(userAccount.equals(account)) {
				elUser.getElementsByTagName("userPwd").item(0).setTextContent(newPwd);
			}
		}
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}

		return datas;
	}
	
	/**
	 * ѯûϢ
	 * @return
	 */
	public Datas queryAllUser(String admin) {
		Datas datas = new Datas();
		List<User> userList = new ArrayList<User>();
		Document doc = getDocument("data/User.xml");

		NodeList userListNode = doc.getElementsByTagName("User");

		for (int i = 0; i < userListNode.getLength(); i++) {
			Element elUser = (Element) userListNode.item(i);
			if(admin.equals(elUser.getAttribute("admin"))) {
				String userId = elUser.getElementsByTagName("userId").item(0)
						.getTextContent();
				String userAccount = elUser.getElementsByTagName("userAccount").item(0)
						.getTextContent();
				String userPwd = elUser.getElementsByTagName("userPwd").item(0)
						.getTextContent();
				String userName = elUser.getElementsByTagName("userName").item(0)
						.getTextContent();
				String phoneNum = elUser.getElementsByTagName("phoneNum").item(0)
						.getTextContent();
				User user = new User(null,userId,userAccount,userPwd,userName,
						phoneNum,null);
				userList.add(user);
			}
		}
		datas.setUserList(userList);
		datas.setFlag(SysConstants.SYS_SUCCESS);
		return datas;
	}
	
	/**
	 * ѯԱϢ
	 * @return
	 */
	public Datas queryVip() {
		Datas datas = new Datas();
		List<Vip> vipList = new ArrayList<Vip>();
		Document doc = getDocument("data/Vip.xml");

		NodeList vipListNode = doc.getElementsByTagName("Member");

		for (int i = 0; i < vipListNode.getLength(); i++) {
			Element elVip = (Element) vipListNode.item(i);
			String vipNum = elVip.getElementsByTagName("vipNum").item(0)
					.getTextContent();
			int integral = Integer.parseInt(elVip.getElementsByTagName("integral").item(0)
					.getTextContent());
			Vip vip = new Vip(vipNum,integral);
			vipList.add(vip);
		}
		datas.setVipList(vipList);
		datas.setFlag(SysConstants.SYS_SUCCESS);
		return datas;
	}
	
	/**
	 * Ӳ˵
	 * @param menuId
	 * @param menuName
	 * @param menuUnit
	 * @param menuInfo
	 * @param menuPrice
	 * @param menuCount
	 * @return
	 */
	public Datas addMenu(String menuId,String menuName,String menuUnit,
			String menuInfo,float menuPrice,float menuCount,String releaseDate,String qualityLife) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Menu.xml");
		
		NodeList menuListNode = doc.getElementsByTagName("Menu");

		for (int i = 0; i < menuListNode.getLength(); i++) {
			Element elMenu = (Element) menuListNode.item(i);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			String name = elMenu.getElementsByTagName("menuName").item(0)
					.getTextContent();
			if(id.equals(menuId)) {
				datas.setFlag(SysConstants.SYS_MENUIDISEXIT);
				return datas;
			} 
			
			if(name.equals(menuName)) {
				datas.setFlag(SysConstants.SYS_MENUNAMEISEXIT);
				return datas;
			}
		}
			
		Element elMenus = doc.getDocumentElement();
//		private String menuId;
//		private String menuName;
//		private String menuUnit;
//		private String menuInfo;
//		private int menuPrice;
//		private int menuCount;
		Element elMenu = doc.createElement("Menu");
		Element elMenuId = doc.createElement("menuId");
		elMenuId.setTextContent(menuId);
		elMenu.appendChild(elMenuId);
		Element elMenuName = doc.createElement("menuName");
		elMenuName.setTextContent(menuName);
		elMenu.appendChild(elMenuName);
		Element elMenuUnit = doc.createElement("menuUnit");
		elMenuUnit.setTextContent(menuUnit);
		elMenu.appendChild(elMenuUnit);
		Element elMenuInfo = doc.createElement("menuInfo");
		elMenuInfo.setTextContent(menuInfo);
		elMenu.appendChild(elMenuInfo);
		Element elMenuPrice = doc.createElement("menuPrice");
		elMenuPrice.setTextContent(String.valueOf(menuPrice));
		elMenu.appendChild(elMenuPrice);
		Element elMenuCount = doc.createElement("menuCount");
		elMenuCount.setTextContent(String.valueOf(menuCount));
		elMenu.appendChild(elMenuCount);
		
		Element elMenuReleaseDate = doc.createElement("menuReleaseDate");
		elMenuReleaseDate.setTextContent(releaseDate);
		elMenu.appendChild(elMenuReleaseDate);
		
		Element elMenuQualityLife = doc.createElement("menuQualityLife");
		elMenuQualityLife.setTextContent(qualityLife);
		elMenu.appendChild(elMenuQualityLife);
		
		elMenus.appendChild(elMenu);
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	/**
	 * ɾ˵
	 * @param menuId
	 * @return
	 */
	public Datas deleteMenu(String menuId) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Menu.xml");
		
		NodeList menuListNode = doc.getElementsByTagName("Menu");

		int i;
		int m = menuListNode.getLength();
		for (i = 0; i < m; i++) {
			Element elMenu = (Element) menuListNode.item(i);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			float count = Float.valueOf(elMenu.getElementsByTagName("menuCount").item(0)
					.getTextContent());
			if(id.equals(menuId)) {
				if(count <= 0) {
					Element elMenus = (Element)doc.getElementsByTagName("Menus").item(0);
					elMenus.removeChild(elMenu);
				} else {
					datas.setFlag(SysConstants.SYS_MENUCOUNTISNOTEMPTY);
					return datas;
				}
				break;
			} 
		}
	
		
		if(i == m) {
			datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
			return datas;
		}
			
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	public Datas deleteBadMenu(String menuId) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Menu.xml");
		
		NodeList menuListNode = doc.getElementsByTagName("Menu");

		int i;
		int m = menuListNode.getLength();
		for (i = 0; i < m; i++) {
			Element elMenu = (Element) menuListNode.item(i);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			if(id.equals(menuId)) {
				Element elMenus = (Element)doc.getElementsByTagName("Menus").item(0);
				elMenus.removeChild(elMenu);
				break;
			} 
		}
	
		if(i == m) {
			datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
			return datas;
		}
			
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	public Datas clearBuyMenus(String userAccount,Boolean type) {
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");
		HashMap<String,String> map = new HashMap<String,String>(); 
		NodeList userListNode = doc.getElementsByTagName("User");
		for(int i = 0;i<userListNode.getLength();i++) {
			Element elUser = (Element)userListNode.item(i);
			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if(userAccount.equals(account)) {
				Element elBuyMenus = (Element)elUser.getElementsByTagName("buyMenus").item(0);
				NodeList buyMenuListNode = elBuyMenus.getElementsByTagName("buyMenu");
				for(int j = 0;j<buyMenuListNode.getLength();j++) {
					Element elBuyMenu = (Element)buyMenuListNode.item(j);
					map.put(elBuyMenu.getTextContent(), elBuyMenu.getAttribute("count"));
					elBuyMenus.removeChild(buyMenuListNode.item(j));
				}
			}
		}
			
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		
		if(type == false) {
			Document docMenu = getDocument("data/Menu.xml");
			NodeList menuListNode = docMenu.getElementsByTagName("Menu");
	
			for(Map.Entry<String,String> m: map.entrySet()){ 
				for (int i = 0; i < menuListNode.getLength(); i++) {
					Element elMenu = (Element) menuListNode.item(i);
					String menuId = elMenu.getElementsByTagName("menuId").item(0)
							.getTextContent();
					if(m.getKey().equals(menuId)) {
						float oldCount = Float.parseFloat(m.getValue());
						Element elBuyMenuCount = (Element)elMenu.getElementsByTagName("menuCount").item(0);
						float newCount = oldCount+Float.parseFloat(elBuyMenuCount.getTextContent());
						elBuyMenuCount.setTextContent(String.valueOf(newCount));
					}
				}
			} 
			if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", docMenu))) {
				datas.setFlag(SysConstants.SYS_ERROR);
			} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", docMenu))) {
				datas.setFlag(SysConstants.SYS_SUCCESS);
			}
		}
		
		return datas;
	}
	
	/**
	 * ѯв˵
	 * @return
	 */
	public Datas queryAllMenu() {
		Datas datas = new Datas();
		List<Menu> menuList = new ArrayList<Menu>();
		Document doc = getDocument("data/Menu.xml");

		NodeList menuListNode = doc.getElementsByTagName("Menu");

		for (int i = 0; i < menuListNode.getLength(); i++) {
			Element elMenu = (Element) menuListNode.item(i);
//			private String menuId;
//			private String menuName;
//			private String menuUnit;
//			private String menuInfo;
//			private int menuPrice;
//			private int menuCount;
			String menuId = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			String menuName = elMenu.getElementsByTagName("menuName").item(0)
					.getTextContent();
			String menuUnit = elMenu.getElementsByTagName("menuUnit").item(0)
					.getTextContent();
			String menuInfo = elMenu.getElementsByTagName("menuInfo").item(0)
					.getTextContent();
			float menuPrice = Float.parseFloat(elMenu.getElementsByTagName("menuPrice").item(0)
					.getTextContent());
			float menuCount = Float.parseFloat(elMenu.getElementsByTagName("menuCount").item(0)
					.getTextContent());
			String releaseDate = elMenu.getElementsByTagName("menuReleaseDate").item(0)
					.getTextContent();
			String qualityLife = elMenu.getElementsByTagName("menuQualityLife").item(0)
					.getTextContent();
			Menu menu = new Menu(menuId, menuName, menuUnit, menuInfo, menuPrice, menuCount, releaseDate, qualityLife);
			menuList.add(menu);
		}
		datas.setMenuList(menuList);
		datas.setFlag(SysConstants.SYS_SUCCESS);
		return datas;
	}
	
	/**
	 * ޸Ĳ˵
	 * @param id
	 * @param attribute
	 * @param type
	 * @return
	 */
	public Datas updateMenuById(String id,String attribute,String type) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Menu.xml");

		NodeList menuListNode = doc.getElementsByTagName("Menu");

		int i;
		int m = menuListNode.getLength();
		for (i = 0; i < m; i++) {
			Element elMenu = (Element) menuListNode.item(i);
//			private String menuId;
//			private String menuName;
//			private String menuUnit;
//			private String menuInfo;
//			private int menuPrice;
//			private int menuCount;
			String menuId = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			
			if(id.equals(menuId)) {
				if(type.equals(SysConstants.SYS_UPDATEMENUNAMEBYID)) {
					for (int j = 0; j < menuListNode.getLength(); j++) {
						Element elMenun = (Element) menuListNode.item(j);
						String name = elMenun.getElementsByTagName("menuName").item(0)
								.getTextContent();		
						if(name.equals(attribute)) {
							datas.setFlag(SysConstants.SYS_MENUNAMEISEXIT);
							return datas;
						}
					}
					elMenu.getElementsByTagName("menuName").item(0).setTextContent(attribute);
				} else if(type.equals(SysConstants.SYS_UPDATEMENUUNITBYID)) {
					elMenu.getElementsByTagName("menuUnit").item(0).setTextContent(attribute);
				} else if(type.equals(SysConstants.SYS_UPDATEMENUINFOBYID)) {
					elMenu.getElementsByTagName("menuInfo").item(0).setTextContent(attribute);
				} else if(type.equals(SysConstants.SYS_UPDATEMENUPRICEBYID)) {
					elMenu.getElementsByTagName("menuPrice").item(0).setTextContent(attribute);
				} else if(type.equals(SysConstants.SYS_UPDATEMENUCOUNTBYID)) {
					elMenu.getElementsByTagName("menuCount").item(0).setTextContent(attribute);
				}
				break;
			}
		}
		
		if(i == m) {
			datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
			return datas;
		}
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	/**
	 * ݱŲѯ˵
	 * @param id
	 * @return
	 */
	public Datas queryMenuById(String id) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Menu.xml");
		Menu menu = null;
		NodeList menuListNode = doc.getElementsByTagName("Menu");

		int i;
		int m = menuListNode.getLength();
		for (i = 0; i < m; i++) {
			Element elMenu = (Element) menuListNode.item(i);
//			private String menuId;
//			private String menuName;
//			private String menuUnit;
//			private String menuInfo;
//			private int menuPrice;
//			private int menuCount;
			String menuId = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			float count = Float.valueOf(elMenu.getElementsByTagName("menuCount").item(0)
					.getTextContent());
			if(id.equals(menuId)) {
				if(count <= 0) {
					datas.setFlag(SysConstants.SYS_MENUCOUNTISEMPTY);
					return datas;
				}
				String menuName = elMenu.getElementsByTagName("menuName").item(0)
						.getTextContent();
				String menuUnit = elMenu.getElementsByTagName("menuUnit").item(0)
						.getTextContent();
				String menuInfo = elMenu.getElementsByTagName("menuInfo").item(0)
						.getTextContent();
				float menuPrice = Float.parseFloat(elMenu.getElementsByTagName("menuPrice").item(0)
						.getTextContent());
				float menuCount = Float.parseFloat(elMenu.getElementsByTagName("menuCount").item(0)
						.getTextContent());
				String releaseDate = elMenu.getElementsByTagName("menuReleaseDate").item(0)
						.getTextContent();
				String qualityLife = elMenu.getElementsByTagName("menuQualityLife").item(0)
						.getTextContent();
				menu = new Menu(menuId, menuName, menuUnit, menuInfo, menuPrice, menuCount, releaseDate, qualityLife);
				break;
			}
		}
		
		if(i == m) {
			datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
			return datas;
		}
		
		datas.setMenu(menu);
		datas.setFlag(SysConstants.SYS_SUCCESS);
		return datas;
	}
	
	
	/**
	 * ˵빺ﳵ
	 * @param userAccount
	 * @param menuId
	 * @param menuBuyCount
	 * @return
	 */
	public Datas addBuyMenu(String userAccount,String menuId,float menuBuyCount) {
		Datas datas = new Datas();
		
		Document docMenu = getDocument("data/Menu.xml");
		NodeList menuListNode = docMenu.getElementsByTagName("Menu");
		Element elMenuCount = null;

		int k;
		int f = menuListNode.getLength();
		for (k = 0; k < f; k++) {
			Element elMenu = (Element) menuListNode.item(k);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			if(id.equals(menuId)) {
				elMenuCount = (Element)elMenu.getElementsByTagName("menuCount").item(0);
				float oldCount = Float.valueOf(elMenuCount.getTextContent());
				if(oldCount < menuBuyCount) {
					datas.setFlag(SysConstants.SYS_MENUCOUNTERROR);
					return datas;
				}
				break;
			} 
		}
		
		if(k == f) {
			datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
			return datas;
		}
		
		
		Document docUser = getDocument("data/User.xml");

		NodeList userList = docUser.getElementsByTagName("User");
		int i;
		for (i = 0; i < userList.getLength(); i++) {
			Element elUser = (Element) userList.item(i);

			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if (userAccount.equals(account)) {			
				Element elBuyMenus = (Element)elUser.getElementsByTagName("buyMenus").item(0);
				NodeList buyMenuList = elBuyMenus.getElementsByTagName("buyMenu");
				
				int j;
				int h = buyMenuList.getLength();
				for(j = 0; j < h; j++) {
					Element elBuyMen = (Element)buyMenuList.item(j);
					String id = elBuyMen.getTextContent();
					if(id.equals(menuId)) {
						datas.setFlag(SysConstants.SYS_MENUALREADYBUY);
						float oldBuyCount = Float.parseFloat(elBuyMen.getAttribute("count"));
						elBuyMen.setAttribute("count", String.valueOf(menuBuyCount+oldBuyCount));
						break;
					}
				}

				if(j == h) {
					Element elBuyMenu = docUser.createElement("buyMenu");
					elBuyMenu.setAttribute("count", String.valueOf(menuBuyCount));
					elBuyMenu.setTextContent(menuId);
					elBuyMenus.appendChild(elBuyMenu);	
				}
				

						
			}

		}
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", docUser))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", docUser))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		} 
		
		docMenu = getDocument("data/Menu.xml");
		menuListNode = docMenu.getElementsByTagName("Menu");

		for (int m = 0; m < menuListNode.getLength(); m++) {
			Element elMenu = (Element) menuListNode.item(m);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			if(id.equals(menuId)) {
				elMenuCount = (Element)elMenu.getElementsByTagName("menuCount").item(0);
				float oldCount = Float.valueOf(elMenuCount.getTextContent());
				float newCount = oldCount- menuBuyCount;
				elMenuCount.setTextContent(String.valueOf(newCount));
				break;
			} 
		}
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", docMenu))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", docMenu))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		} 
		return datas;
	}
	
	/**
	 * ޸Ĳ˵
	 * @param userAccount
	 * @param menuId
	 * @param menuBuyCount
	 * @return
	 */
	public Datas modifyBuyMenuCount(String userAccount,String menuId,float menuBuyCount) {
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");

		NodeList userList = doc.getElementsByTagName("User");
		for (int i = 0; i < userList.getLength(); i++) {
			Element elUser = (Element) userList.item(i);

			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if (userAccount.equals(account)) {
				NodeList buyMenuList = elUser.getElementsByTagName("buyMenu");
				int j;
				int m = buyMenuList.getLength();
				for(j = 0; j < m; j++) {
					Element elBuyMenu = (Element)buyMenuList.item(j);
					if(menuId.equals(elBuyMenu.getTextContent())) {
						
						Document docMenu = getDocument("data/Menu.xml");
						NodeList menuListNode = docMenu.getElementsByTagName("Menu");
						Element elMenuCount = null;

						int k;
						for (k = 0; k < menuListNode.getLength(); k++) {
							Element elMenu = (Element) menuListNode.item(k);
							String id = elMenu.getElementsByTagName("menuId").item(0)
									.getTextContent();
							if(id.equals(menuId)) {
								elMenuCount = (Element)elMenu.getElementsByTagName("menuCount").item(0);
								float oldCount = Float.valueOf(elMenuCount.getTextContent());
								if(oldCount < menuBuyCount) {
									datas.setFlag(SysConstants.SYS_MENUCOUNTERROR);
									return datas;
								}
							} 
						}
						
						elBuyMenu.setAttribute("count", String.valueOf(menuBuyCount));					
						break;
					}
				}	
				
				if(j == m) {
					datas.setFlag(SysConstants.SYS_MENUISNOTEXIST);
					return datas;
				}
			}

		}
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
	
	/**
	 * ɾﳵв˵
	 * @param userAccount
	 * @param menuId
	 * @return
	 */
	public Datas deleteBuyMenu(String userAccount,String menuId) {
		Datas datas = new Datas();
		Document doc = getDocument("data/User.xml");
		float count = 0;
		NodeList userList = doc.getElementsByTagName("User");
		for (int i = 0; i < userList.getLength(); i++) {
			Element elUser = (Element) userList.item(i);

			String account = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if (userAccount.equals(account)) {
				Element elBuyMenus = (Element)elUser.getElementsByTagName("buyMenus").item(0);
				NodeList buyMenuList = elUser.getElementsByTagName("buyMenu");
				for(int j = 0; j < buyMenuList.getLength(); j++) {
					Element elBuyMenu = (Element)buyMenuList.item(j);
					if(menuId.equals(elBuyMenu.getTextContent())) {
						count = Float.parseFloat(elBuyMenu.getAttribute("count"));
						elBuyMenus.removeChild(elBuyMenu);
					}
				}		
			}

		}
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/User.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		
		Document menuDoc = getDocument("data/Menu.xml");
		NodeList menuListNode = menuDoc.getElementsByTagName("Menu");

		for (int j = 0; j < menuListNode.getLength(); j++) {
			Element elMenu = (Element) menuListNode.item(j);
			String id = elMenu.getElementsByTagName("menuId").item(0)
					.getTextContent();
			float oldcount = Float.valueOf(elMenu.getElementsByTagName("menuCount").item(0)
					.getTextContent());
			if(id.equals(menuId)) {
				float newCount = oldcount+count;
				elMenu.getElementsByTagName("menuCount").item(0).setTextContent(String.valueOf(newCount));
				break;
			}
		}
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Menu.xml", menuDoc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Menu.xml", menuDoc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		
		return datas;
	}
	
	
	/**
	 * ѯ
	 * @param account
	 * @return
	 */
	public Datas queryBuyMenus(String account) {
		Datas datas = new Datas();
		List<Menu> menuList = new ArrayList<Menu>();
		HashMap<String,String> map = new HashMap<String,String>(); 
		Document docUser = getDocument("data/User.xml");

		NodeList userListNode = docUser.getElementsByTagName("User");

		for (int i = 0; i < userListNode.getLength(); i++) {
			Element elUser = (Element) userListNode.item(i);

			String userAccount = elUser.getElementsByTagName("userAccount").item(0)
					.getTextContent();
			if(account.equals(userAccount)) {
				Element elBuyMenus = (Element)elUser.getElementsByTagName("buyMenus").item(0);
				NodeList buyMenusListNode = elBuyMenus.getElementsByTagName("buyMenu");
				for(int j = 0; j < buyMenusListNode.getLength(); j++) {
					Element elBuyMenu = (Element)buyMenusListNode.item(j);
					map.put(elBuyMenu.getTextContent(), elBuyMenu.getAttribute("count"));
				}
			}
		}
		
		Document docMenu = getDocument("data/Menu.xml");
		NodeList menuListNode = docMenu.getElementsByTagName("Menu");

		for(Map.Entry<String,String> m: map.entrySet()){ 
			for (int i = 0; i < menuListNode.getLength(); i++) {
				Element elMenu = (Element) menuListNode.item(i);
				String menuId = elMenu.getElementsByTagName("menuId").item(0)
						.getTextContent();
				if(m.getKey().equals(menuId)) {
					String menuName = elMenu.getElementsByTagName("menuName").item(0)
							.getTextContent();
					String menuUnit = elMenu.getElementsByTagName("menuUnit").item(0)
							.getTextContent();
					String menuInfo = elMenu.getElementsByTagName("menuInfo").item(0)
							.getTextContent();
					float menuPrice = Float.parseFloat(elMenu.getElementsByTagName("menuPrice").item(0)
							.getTextContent());
					float menuCount = Float.parseFloat(m.getValue());
					String releaseDate = elMenu.getElementsByTagName("menuReleaseDate").item(0)
							.getTextContent();
					String qualityLife = elMenu.getElementsByTagName("menuQualityLife").item(0)
							.getTextContent();
					Menu menu = new Menu(menuId, menuName, menuUnit, menuInfo, menuPrice, menuCount, releaseDate, qualityLife);
					menuList.add(menu);
				}
			}
		} 

		datas.setMenuList(menuList);
		datas.setFlag(SysConstants.SYS_SUCCESS);
		return datas;
	}
	
	/**
	 * ȡxmlļ
	 * @param path
	 * @return
	 */
	private Document getDocument(String path) {
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document doc = builder.parse(path);
			return doc;

		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * дxmlļ
	 * @param path
	 * @param doc
	 * @return
	 */
	private String writeDocument(String path,Document doc) {
		TransformerFactory tFactory =TransformerFactory.newInstance();
		Transformer transformer = null;
		try {
			transformer = tFactory.newTransformer();
//			transformer.setOutputProperty(OutputKeys.ENCODING, "GB2312");
			transformer.setOutputProperty(OutputKeys.INDENT, "yes");
			transformer.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2"); 
		} catch (TransformerConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return SysConstants.SYS_ERROR;
		}
		DOMSource source = new DOMSource(doc);
		StreamResult result = new StreamResult(new java.io.File(path));
		try {
			transformer.transform(source, result);
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return SysConstants.SYS_ERROR;
		}
		return SysConstants.SYS_SUCCESS;
	}
	
	public Datas checkVip(String vipNum) {
		Datas datas = new Datas();
		Document doc = getDocument("data/Vip.xml");
		NodeList vipList = doc.getElementsByTagName("Member");
		for (int i = 0; i < vipList.getLength(); i++) {
			Element elVip = (Element) vipList.item(i);

			String num = elVip.getElementsByTagName("vipNum").item(0)
					.getTextContent();
			int integral = Integer.valueOf(elVip.getElementsByTagName("integral").item(0)
					.getTextContent());
			if (num.equals(vipNum)) {
				Vip vip = new Vip(num,integral);
				datas.setVip(vip);
				datas.setFlag(SysConstants.SYS_SUCCESS);
				return datas;
			}

		}
		datas.setFlag(SysConstants.SYS_ERROR);
		return datas;
	}
	
	public Datas addIntegral(String vipNum,int integral){
		Datas datas = new Datas();
		Document doc = getDocument("data/Vip.xml");
		
		NodeList vipListNode = doc.getElementsByTagName("Member");

		for (int i = 0; i < vipListNode.getLength(); i++) {
			Element elVip = (Element) vipListNode.item(i);
			String num = elVip.getElementsByTagName("vipNum").item(0)
					.getTextContent();
			int inte = Integer.valueOf(elVip.getElementsByTagName("integral").item(0)
					.getTextContent());
			if(num.equals(vipNum)) {
				elVip.getElementsByTagName("integral").item(0)
				.setTextContent(String.valueOf(inte+integral));
			} 
		}
		
		if(SysConstants.SYS_ERROR.equals(writeDocument("data/Vip.xml", doc))) {
			datas.setFlag(SysConstants.SYS_ERROR);
		} else if(SysConstants.SYS_SUCCESS.equals(writeDocument("data/Vip.xml", doc))) {
			datas.setFlag(SysConstants.SYS_SUCCESS);
		}
		return datas;
	}
}
